"""
Create random address
"""

import time
import defaults
import queues
import state

from bmconfigparser import BMConfigParser

NORMAL = 1
CHAN = 2
MAILINGLIST = 3
SUBSCRIPTION = 4
BROADCAST = 5
str_broadcast_subscribers = '[Broadcast subscribers]'


def accountClass(address):
    """method for checking address type"""
    acc_type = NORMAL
    if BMConfigParser().has_section(address):
        if BMConfigParser().safeGetBoolean(address, 'chan'):
            acc_type = CHAN
        elif BMConfigParser().safeGetBoolean(address, 'mailinglist'):
            acc_type = MAILINGLIST
    elif address == str_broadcast_subscribers:
        acc_type = BROADCAST
    else:
        acc_type = SUBSCRIPTION
    return acc_type


def checkHasNormalAddress():
    """method for checking address"""
    for address in BMConfigParser().addresses():
        acct_type = accountClass(address)

        if acct_type == NORMAL and BMConfigParser().safeGetBoolean(address, 'enabled'):
            return address
    return False


def createAddressIfNeeded(label_text, streamNumberForAddress=1):
    """method for creating random address"""
    if not checkHasNormalAddress():
        queues.addressGeneratorQueue.put((
            'createRandomAddress', 4, streamNumberForAddress,
            label_text,
            1, "", False,
            defaults.networkDefaultProofOfWorkNonceTrialsPerByte,
            defaults.networkDefaultPayloadLengthExtraBytes
        ))
    while state.shutdown == 0 and not checkHasNormalAddress():
        time.sleep(.2)
    return checkHasNormalAddress()
